<id>
din1031:MergedTopicRedirects
</id>

<version>
1.0.0
</version>

<edit file>
$boarddir/index.php
</edit file>

<search for>
		'theme' => array('Themes.php', 'ThemesMain'),
</search for>

<replace>
		'theme' => array('Themes.php', 'ThemesMain'),
		'topicredirect' => array('SplitTopics.php', 'TopicRedirects'),
</replace>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
		$board_info = array('moderators' => array());
		return;
	}
</search for>

<replace>
		$board_info = array('moderators' => array());
		return;
	}
	elseif(!empty($topic)) {
		$context['redirect_topic'] = $topic;
	}
</replace>

<search for>
		elseif ($user_info['is_guest'])
		{
			loadLanguage('Errors');
			is_not_guest($txt['topic_gone']);
		}
		else
			fatal_lang_error('topic_gone', false);
</search for>

<replace>
		elseif ($user_info['is_guest'])
		{
			if(isset($context['redirect_topic']))
				redirectTopic($context['redirect_topic']);
			loadLanguage('Errors');
			is_not_guest($txt['topic_gone']);
		}
		else {
			if(isset($context['redirect_topic']))
				redirectTopic($context['redirect_topic']);
			fatal_lang_error('topic_gone', false);
		}
</replace>

<edit file>
$sourcedir/SplitTopics.php
</edit file>

<search for>
	sendNotifications($ID_TOPIC, 'merge');
</search for>

<replace>
	sendNotifications($ID_TOPIC, 'merge');

	//Set some Redirections :)
	saveTopicRedirects($deleted_topics, $ID_TOPIC);
</replace>

<search for>
// Tell the user the move was done properly.
function MergeDone()
</search for>

<replace>
//Insert a Redirect to the deleted topics.
function saveTopicRedirects($old_topics = array(), $new_topic = null) {
	global $db_prefix;
	
	$new_topic = (int) $new_topic;
	
	if(empty($old_topics) || empty($new_topic))
		return false;
	
	$old_topics = is_array($old_topics) ? $old_topics : array($old_topics);
	
	//Built the Replace INTO sql
	$sql = array();
	foreach($old_topics as $idt) {
		$idt = (int) $idt;
		if(empty($idt) || $new_topic == $idt)
			continue;
		$sql[] = "({$idt}, {$new_topic})";
	}
	if(empty($sql))
		return false;
		
	db_query("
		REPLACE INTO {$db_prefix}topics_redirect
		(old_topic, new_topic)
		VALUES ".implode(", ", $sql), __FILE__, __LINE__);
	
	return true;
}

//Generate a list of the Topic redirects =D
function TopicRedirects() {
	global $context, $txt, $scripturl;

	loadTemplate('SplitTopics');

	// Boldify "Topics Redirect" on the admin bar.
	adminIndex('topics_redirect');

	$subActions = array(
		'list' => array('listTopicRedirects', 'admin_forum'),
		'fix' => array('fixTopicRedirect', 'admin_forum'),
	);

	// Default the sub-action to 'view ban list'.
	$_REQUEST['sa'] = isset($_REQUEST['sa']) && isset($subActions[$_REQUEST['sa']]) ? $_REQUEST['sa'] : 'list';

	// Make sure you can do this.
	isAllowedTo($subActions[$_REQUEST['sa']][1]);

	$context['page_title'] = $txt['topicredirect'];

	// Tabs for browsing the different ban functions.
	$context['admin_tabs'] = array(
		'title' => $txt['topicredirect'],
		'description' => $txt['topicredirect_description'],
		'tabs' => array()
	);
	
	if (allowedTo('admin_forum'))
	{
		$context['admin_tabs']['tabs'][] = array(
			'title' => $txt['topicredirect'],
			'description' => $txt['topicredirect_description'],
			'href' => $scripturl . '?action=topicredirect;sa=list',
			'is_selected' => $_REQUEST['sa'] == 'list',
		);
	}

	// Call the right function for this sub-acton.
	$subActions[$_REQUEST['sa']][0]();
}

//List the current Merged Redirects
function listTopicRedirects() {
	global $context, $txt, $db_prefix, $modSettings, $scripturl;

	// Setup the template.
	$context['sub_template'] = 'list_topic_redirects';
	$context['page_title'] = $txt['topicredirect'];
	$context['page_index'] = '[0]';
	$context['redirect_topics'] = array();
	
	// Saving?
	if (isset($_POST['save_settings']) && !empty($_POST['delete']))
	{
		checkSession();
		deleteTopicRedirect($_POST['delete']);
		redirectexit('action=topicredirect;sa=list;done');
	}
	
	$_REQUEST['start'] = !isset($_REQUEST['start']) ? 0 : (int) $_REQUEST['start'];
	
	$context['max_redirects'] = 0;
	$limit = 15;

	//Load the Redirected Topics.	
	$count = db_query("SELECT COUNT(*) FROM {$db_prefix}topics_redirect", __FILE__, __LINE__);
	list($context['max_redirects']) = mysql_fetch_row($count);
	mysql_free_result($count);
	
	//Correct the Start :)
	if($limit > $context['max_redirects'])
		$limit = $context['max_redirects'];
	if($_REQUEST['start'] > $context['max_redirects'])
		$_REQUEST['start'] = $context['max_redirects'] - $limit;
	if($_REQUEST['start'] < 0)
		$_REQUEST['start'] = 0;
	
	// Construct the page index.
	if(empty($context['max_redirects']))
		return;

	$context['page_index'] = constructPageIndex($scripturl . '?action=topicredirect;sa=list', $_REQUEST['start'], $context['max_redirects'], $limit);
	
	//Okay load it :)
	$request = db_query("
		SELECT old_topic, new_topic 
		FROM {$db_prefix}topics_redirect
		LIMIT $_REQUEST[start], $limit", __FILE__, __LINE__);

	$collect_topics = array();
	while($row = mysql_fetch_assoc($request)) {
		$context['redirect_topics'][$row['old_topic']] = array(
			'old_topic' => $row['old_topic'],
			'new_topic' => $row['new_topic'],
			'subject' => '<a href="'.$scripturl.'?topic='.$row['new_topic'].'.0">'.$txt['topicredirect_no_topic_found'].'</a>',
			'fix_it' => true,
		);
		
		$collect_topics[$row['new_topic']] = $row['new_topic'];
	}
	mysql_free_result($request);
	
	if(empty($collect_topics))
		return;
	
	//Load the Topicsubject
	$request = db_query("
		SELECT ID_TOPIC, ID_FIRST_MSG 
		FROM {$db_prefix}topics
		WHERE ID_TOPIC IN (".implode(", ", $collect_topics).")
		LIMIT $limit", __FILE__, __LINE__);

	$id_msg = array();
	while($row = mysql_fetch_assoc($request)) {
		$id_msg[$row['ID_TOPIC']] = $row['ID_FIRST_MSG'];
	}
	mysql_free_result($request);
	
	//Now load the subject... step by step it's faster, because of the large message table ;)
	$request = db_query("
		SELECT ID_MSG, subject
		FROM {$db_prefix}messages
		WHERE ID_MSG IN (".implode(", ", $id_msg).")
		LIMIT ".count($id_msg), __FILE__, __LINE__);
	
	$subjects = array();
	while($row = mysql_fetch_assoc($request)) {
		$subjects[$row['ID_MSG']] = $row['subject'];
	}
	mysql_free_result($request);
	
	if(empty($subjects))
		return;

	foreach($context['redirect_topics'] as $id_old => $data) {
		if(!isset($id_msg[$data['new_topic']]))
			continue;
		$subject = $subjects[$id_msg[$data['new_topic']]];
		$context['redirect_topics'][$id_old]['subject'] = '<a href="'.$scripturl.'?topic='.$data['new_topic'].'.0">'.$subject.'</a>';
		$context['redirect_topics'][$id_old]['fix_it'] = false;
	}
}

/*
	Fix a redirect, 
	try to find the new end position if exists, 
	if it not exists it will be delete.
*/
function fixTopicRedirect() {
	global $db_prefix;
	
	//Chech my vars or set it ;)	
	if(!isset($_GET['id']) || !is_numeric($_GET['id']))
		redirectexit('action=topicredirect;sa=list;error');

	$_GET['id'] = (int) $_GET['id'];
	$old = 0;
	$new = 0;
	$rep = 0;
	$fixit = 0;
	
	//Load the old data 
	$request = db_query("
		SELECT old_topic, new_topic
		FROM {$db_prefix}topics_redirect
		WHERE old_topic = $_GET[id]
		LIMIT 1", __FILE__, __LINE__);
	list($old, $new) = mysql_fetch_row($request);
	mysql_free_result($request);
	
	if(empty($old))
		redirectexit('action=topicredirect;sa=list;error');

	//Is this there are fix needed?
	$request = db_query("
		SELECT ID_TOPIC
		FROM {$db_prefix}topics
		WHERE ID_TOPIC = $new
		LIMIT 1", __FILE__, __LINE__);
	
	list($fixit) = mysql_fetch_row($request);
	mysql_free_result($request);

	if(!empty($fixit))
		redirectexit('action=topicredirect;sa=list;done');

	//Let's find the new connection if exist :)
	$request = db_query("
		SELECT new_topic
		FROM {$db_prefix}topics_redirect
		WHERE old_topic = $new
		LIMIT 1", __FILE__, __LINE__);
	
	list($rep) = mysql_fetch_row($request);
	mysql_free_result($request);

	//No Redirection any more? Than it's a delted topic :)
	if(empty($rep))	{
		deleteTopicRedirect($old);
		redirectexit('action=topicredirect;sa=list;done');
	}
	//Fix it to the new Position, you will love it *g*
	else {
		saveTopicRedirects($old, $rep);
		redirectexit('action=topicredirect;sa=list;done');
	}
}

//Insert a Redirect to the deleted topics... only for user who allowed to moderate forum!
function deleteTopicRedirect($old_topics = array()) {
	global $db_prefix;
	
	if(empty($old_topics) || !allowedTo('admin_forum'))
		return false;
	
	$old_topics = !is_array($old_topics) ? array($old_topics) : $old_topics;
	
	//Delete the Redirects
	foreach($old_topics as $did) {
		$did = (int) $did;
		if(empty($did))
			continue;
		db_query("
			DELETE FROM {$db_prefix}topics_redirect
			WHERE old_topic = $did
			LIMIT 1", __FILE__, __LINE__);
	}	
	return true;
}

// Tell the user the move was done properly.
function MergeDone()
</replace>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
		if (allowedTo(array('admin_forum', 'moderate_forum')))
			$context['admin_areas']['layout']['areas']['posts_and_topics'] = '<a href="' . $scripturl . '?action=postsettings">' . $txt['manageposts'] . '</a>';
</search for>

<replace>
		if (allowedTo(array('admin_forum', 'moderate_forum')))
			$context['admin_areas']['layout']['areas']['posts_and_topics'] = '<a href="' . $scripturl . '?action=postsettings">' . $txt['manageposts'] . '</a>';
		if (allowedTo('admin_forum'))
			$context['admin_areas']['layout']['areas']['topics_redirect'] = '<a href="' . $scripturl . '?action=topicredirect">' . $txt['topicredirect'] . '</a>';
</replace>

<search for>
// Make sure the browser doesn't come back and repost the form data.  Should be used whenever anything is posted.
function redirectexit($setLocation = '', $refresh = false)
{
</search for>

<replace>
// Try to find a redirected merged old topic and go there...
function redirectTopic($old_topic = null, $returnid = false)
{
	global $db_prefix;
	
	$old_topic = (int) $old_topic;
	if(empty($old_topic))
		return false;
	
	$topics = array();
	
	$request = db_query("
		SELECT old_topic, new_topic
		FROM {$db_prefix}topics_redirect 
		WHERE old_topic = $old_topic
		LIMIT 1", __FILE__, __LINE__);
	
	$topics = mysql_fetch_assoc($request);
	mysql_free_result($request);
	
	//Oh redirect to the new topic ;D
	if(empty($topics))
		return false;
	elseif($returnid == true)
		return $topics['new_topic'];
	else
		redirectexit('topic='.$topics['new_topic'].'.0');
}

// Make sure the browser doesn't come back and repost the form data.  Should be used whenever anything is posted.
function redirectexit($setLocation = '', $refresh = false)
{
</replace>

<edit file>
$themedir/SplitTopics.template.php
</edit file>

<search for>
function template_merge_done()
{
</search for>

<replace>
// Template for editing topic redirectings.
function template_list_topic_redirects()
{
	global $context, $settings, $options, $txt, $scripturl, $modSettings;

	echo '
	<form action="', $scripturl, '?action=topicredirect;sa=list" method="post" accept-charset="', $context['character_set'], '">
		<table border="0" cellspacing="0" cellpadding="4" align="center" width="80%" class="tborder">
			<tr class="titlebg">
				<td colspan="2">', $txt['topicredirect'], '</td>
			</tr>
			<tr class="windowbg2">
				<td>
					<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
						<tr class="catbg">
							<td align="left" colspan="3">
								<b>', $txt[139], ':</b> ', $context['page_index'], '
							</td>
						</tr>
						<tr class="titlebg">
							<td valign="top" width="15%">
								', $txt['topicredirect_oldtopic'] ,'
							</td>
							<td valign="top">
								', $txt['topicredirect_totopic'] ,'
							</td>
							<td align="center" width="5%">
								'.(!empty($context['redirect_topics']) ? '<input type="checkbox" class="check" onclick="invertAll(this, this.form);" />' : '').'
							</td>
						</tr>';
	if (empty($context['redirect_topics']))
		echo '
						<tr>
							<td class="windowbg" colspan="3">(', $txt['search_no_results'], ')</td>
						</tr>';
	else
	{
		$a = false;
		foreach ($context['redirect_topics'] as $redirecttopics)
		{	
				$a = !$a;
				echo '
						<tr>
							<td class="windowbg'.($a ? '' : 2).'" width="15%">
								'. $redirecttopics['old_topic'] .'
							</td>
							<td class="windowbg'.($a ? '' : 2).'">
								'. $redirecttopics['subject'] .($redirecttopics['fix_it'] ? '
								<a href="'.$scripturl.'?action=topicredirect;sa=fix;id='.$redirecttopics['old_topic'].'">('.$txt['topicredirect_fix_it'].')</a>' : '').'
							</td>
							<td align="center" class="windowbg'.($a ? '' : 2).'" width="5%">
								<input type="checkbox" name="delete[]" value="', $redirecttopics['old_topic'], '" class="check" />
							</td>
						</tr>';
		} 
	}
	echo '
						<tr class="catbg">
							<td align="left" colspan="3">
								<b>', $txt[139], ':</b> ', $context['page_index'], '
							</td>
						</tr>
					</table>
				</td>
			</tr>
			<tr class="windowbg2">
				<td align="right" colspan="2">
					<input type="submit" name="save_settings" value="'.$txt['topicredirect_delete'].'" onclick="return confirm(\'' . $txt['topicredirect_delete_ask'] . '\');" /> 
				</td>
			</tr>
		</table>
		<input type="hidden" name="sc" value="', $context['session_id'], '" />
	</form>';
}

function template_merge_done()
{
</replace>